config/routes.rb
Rails.application.routes.draw do
  
  devise_for :users, controllers: { registrations: "registrations" }
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

 unauthenticated do
  as :user do
    root :to => 'pages#home'
  end
 end
 
  authenticated do
      root :to => 'products#index'
  end

  root 'pages#home'
  get 'dashboard' => 'pages#dashboard'

  get 'contact' => 'pages#contact'

  get 'shopify/auth' => 'shopifys#auth'
  get 'shopify/install' => 'shopifys#install'


  resources :products
  resources :categories
  resources :charges

  get 'affiliate/home', to: 'affiliates#home'

  get 'unsubscribe', to: 'charges#endsubscription'

  get 'subscribe', to: 'charges#new'
  get 'profile', to: 'pages#profile'

  resources :users, except: [:new]
  resources :influencers 
  resources :audiences
  resources :faqs
  resources :engagements

  get 'pricing', to: 'pages#pricing'
  get 'login', to: 'sessions#new'
  post 'login', to: 'sessions#create'
  delete 'logout', to: 'sessions#destroy'

  get 'admin', to: 'pages#admin'
end

app/models/faq.rb
class Faq < ApplicationRecord
    validates :question , presence: true
    validates :answer, presence: true
    validates :sortId, presence: true, numericality: { only_integer: true }
end

app/controllers/faqs_controller.rb
class FaqsController < ApplicationController

    #before_action :authenticate_user!
    #before_action :is_user_subscribed
    
    def index
        @faqs = Faq.all.order('"sortId" ASC')
    end

    def new
        if current_user.admin?
            @faq = Faq.new
        else
            redirect_to root_path
        end

    end

    def create 
        if  current_user.admin?
            @faq = Faq.new(faq_params)
            if @faq.save
                redirect_to faqs_path
            else
                render 'new'
            end
        else
            redirect_to root_path
        end
    end

    def update
        if  current_user.admin?
            set_faq
            if @faq.update(faq_params)
                redirect_to faqs_path
            else
                render 'edit' 
            end
        else
            redirect_to root_path
        end
    end

    def edit
        if  current_user.admin?
          set_faq
        else
            redirect_to root_path
        end
    end

    def show 

    end

    def destroy
        set_faq
        @faq.delete

        redirect_to faqs_path
    end

    private
        def faq_params
            params.require(:faq).permit(:question,:answer,:sortId)
        end

        def set_faq
            @faq = Faq.find(params[:id])
        end

        def is_user_subscribed
            if !current_user.subscribed? and !current_user.admin?
                redirect_to subscribe_path
            end
        end

        
end

app/views/faqs/_form.html.erb
<%= form_for(@faq, html:{class: "form-horizontal", role: "form"}) do |f| %>
    <div class="form-group">
        <div class="control-label col-sm-2">  
            <%= f.label :question %> 
        </div>
    <div class="col-sm-8">
        <%= f.text_field :question, class: "form-control", autofocus: true %>
    </div>
    </div>
    <div class="form-group">
       <div class="control-label col-sm-2">  
            <%= f.label :answer %> 
       </div>
        <div class="col-sm-8">
            <%= f.text_area :answer, rows: 10, class: "form-control" %>
            <p class="help-block">Formatting will be saved</p>
        </div>
    </div>
    <div class="form-group">
       <div class="control-label col-sm-2">  
            <%= f.label :sortId %> 
       </div>
        <div class="col-sm-4">
            <%= f.text_field :sortId, rows: 10, class: "form-control" %>
        </div>
    </div>
    <div class="form-group">
        <div class="col-sm-offset-2 col-sm-4">
            <%= f.submit class: 'btn btn-primary btn-lg' %>
        </div>
    </div>
<% end %>

app/views/faqs/edit.html.erb
<div class="container">
    <h1 align="center">New Faq</h1>
        <hr style="width: 50%;">
    <%= render 'form' %>
    <div class="col-md-12 col-md-offset-2">
        <%= link_to "Delete this Faq", faq_path(@faq), method: :delete %>
    </div>
</div>

app/views/faqs/index.html.erb
<div class="container productindex">
    <section class="product-navigation header top-margin">
        <h1 class="animated">Frequently Asked Questions (FAQ)</h1>
    </section>
    <hr>
    <% @faqs.each do |faq| %>
        <div class="row">
            <div class="col-md-6 col-xs-12">
             <% if current_user.present? %>
                <% if current_user.admin? %>
                    <%= link_to(edit_faq_path(faq)) do %>
                        <button style="position: absolute;" class="btn btn-primary btn-sm">Edit</button>
                    <% end %>
                <% end %>
            <% end %>
                <div class="tab">
                    <button class="tablinks" onclick="openQuestion(event, <%= faq.id %>)" ><%= faq.question %></button>
                </div>
            </div>
            <div class="col-md-6 col-xs-12">
                <div id="<%= faq.id %>" class="tabcontent">
                     <p><%= simple_format(faq.answer) %> </p>
                </div>
            </div>
        </div>
    <% end %>
</div>
<script>
    function openQuestion(evt, question) {
      var i, tabcontent, tablinks;
      tabcontent = document.getElementsByClassName("tabcontent");
      for (i = 0; i < tabcontent.length; i++) {
        tabcontent[i].style.display = "none";
      }
      tablinks = document.getElementsByClassName("tablinks");
      for (i = 0; i < tablinks.length; i++) {
        tablinks[i].className = tablinks[i].className.replace(" active", "");
      }
      document.getElementById(question).style.display = "block";
      evt.currentTarget.className += " active";
    }
    // tabcontent = document.getElementsByClassName("tabcontent");
    //   for (i = 0; i < tabcontent.length; i++) {
    //     tabcontent[i].style.display = "none";
    // document.getElementsByClassName("tablinks")[0].className += " active";
    // document.getElementsByClassName("tabcontent")[0].style.display = "none";
    var first = document.getElementsByClassName("tablinks")[0]
    openQuestion(onclick,first)
</script>

app/views/faqs/new.html.erb
<div class="container">
    <h1 align="center">New Faq</h1>
        <hr style="width: 50%;">
    <%= render 'form' %>
</div>